/* Copyright (C) 2003 Albert Seward
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package sf.jlink;

import java.io.*;
import java.net.*;

public class ClientDetector extends Thread {
    JConfig config;
    DatagramSocket udpSocket;

    public ClientDetector(JConfig config) {
        this.config = config;        
    }
    
    
    public void run() {
        try {
            udpSocket = new DatagramSocket(8000);
            udpSocket.setBroadcast(true);
            while(true) {               
                byte udpData[] = new byte[100]; 
                DatagramPacket udpPacket = new DatagramPacket(udpData, udpData.length);
                udpSocket.receive(udpPacket);
                String msg = new String(udpData).trim();
                if(msg.equals("ARE_YOU_KISS_PCLINK_SERVER?")) {
					sleep(100);
					InetAddress player = udpPacket.getAddress();
					int playerPort = udpPacket.getPort();
					byte[] reply = config.getServerName().getBytes();
					JLink.debug("Found a KiSS player! " + player.getHostAddress());
					udpSocket.send(new DatagramPacket(reply, reply.length, player, playerPort));
				}
            }
        } catch(Exception e) {
            JLink.error("Problem with automatic player detector.\nFeature will shut down", null, false);
            try {
                udpSocket.close();
            } catch(Exception foo) {}
        }
    }
}

