/* Copyright (C) 2003 Albert Seward
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  This file has been modified by Jrgen stensen (oldman) feb 2005 to make palylist work 
 *  properly. The sort of the playlist folder has been removed.
 *
 */

package sf.jlink;

import java.io.*;
import java.util.*;

public class FileSystem {
    public static String pathSeparatorChar = "/";
    public Vector mounts = new Vector();
    private class FileListSort implements Comparator {
        public int compare(Object o1, Object o2) {
            String s1 = (String)o1;
            String s2 = (String)o2;
            int ret = (s1.endsWith(pathSeparatorChar)?-1:0) - (s2.endsWith(pathSeparatorChar)?-1:0);
            return(ret==0?s1.compareTo(s2):ret);
        }
    }
       
    public File getFile(String path) throws FileNotFoundException {
        if(path.startsWith("INTERNAL:"))
            return new File(path.substring(9));
          
        Vector ret = new Vector();
        for(Iterator i = mounts.iterator(); i.hasNext();) {
            File file = ((Mount)i.next()).get(path);
            if(file != null)
                return(file);
        }
        throw new FileNotFoundException(path);
    }
    
    public Vector list(String path) throws DirectoryNotFoundException {
        Vector ret = new Vector();
        boolean error = true;
        for(Iterator i = mounts.iterator(); i.hasNext();) {
            Vector list = ((Mount)i.next()).list(path);
            if(list != null) {
                ret.removeAll(list);
                ret.addAll(list);
                error = false;
            }
        }
        
        if(error)
            throw new DirectoryNotFoundException(path);
       if(path.indexOf(".pls")>-1||path.indexOf(".m3u")>-1){
       }else
       {
         Collections.sort(ret, new FileListSort());
	 }
        return(ret);   
    }
    
    public static boolean isValidStart(String path) {
        return path.matches("^\\" + FileSystem.pathSeparatorChar + "(AUDIO|VIDEO|PICTURE)(\\" + 
        FileSystem.pathSeparatorChar + ".*)??");
    }
}
