/*
 * JWindow.java
 *
 * Created on 13 dcembre 2003, 19:17
 */

package sf.jlink;
import javax.swing.*;
import java.awt.*;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import java.util.*;
import java.awt.event.*;
import snoozesoft.systray4j.*;
import javax.swing.border.*;
import java.math.*;
import java.net.*;
/**
 *
 * @author  Johell
 */
public class JWindow extends javax.swing.JFrame  implements SysTrayMenuListener,  WindowListener{
    JConfig config;
    OptionsDialog optionsDialog;
    FileSystem fs;
    SysTrayMenu sysTray = null;
    SysTrayMenuItem itemSkip = null;
    /** Creates new form JWindow */
    
 
    public JWindow(JConfig config) {
         setIconImage(new ImageIcon("kiss.jpg").getImage());
        this.config = config;
        
        
        initComponents();
        Dimension sc = Toolkit.getDefaultToolkit().getScreenSize();
        this.setLocation((sc.width - getWidth()) / 2, (sc.height - getHeight()) / 2);
       
        
        //buffer size
        SendBuffer.setText(config.getBufferSize());
        
        //ext files
        
        VideoExt.setText(config.getExtFile(0));
        AudioExt.setText(config.getExtFile(1));
        PictureExt.setText(config.getExtFile(2));
        subExt.setText(config.getExtFile(3));
       //set extension display 
        
        chkDispExtVid.setSelected(config.getExtDisplay(0));
        chkDispExtAud.setSelected(config.getExtDisplay(1));
        chkDispExtPict.setSelected(config.getExtDisplay(2));
        subDelayApply.setSelected(config.getExtDisplay(3));
        showTV.setSelected(config.getSubTV());
        //clean check
        chkClean.setSelected(config.getClean());
        //clean text
        userClean.setText(config.getCleanStrings());
        
        subProg.setText(config.getSubProg());
        subDelay.setText(config.getSubDelay());
        
        
        
        
        //security buttons
        if (config.getSecurityModel() == 1) {
            allowAllButton.setSelected(true);
        }
        else if (config.getSecurityModel() == 2) {
            allowLocalButton.setSelected(true);
        }
        else    if (config.getSecurityModel() == 3) {
            allowSpecButton.setSelected(true);
            allowSpecTextField.setText(config.getAllowIP());
        }
        
        //set server ip label
        try {
            IpLabel.setText(InetAddress.getLocalHost().getHostAddress());
        } catch(Exception e) {
            IpLabel.setText( "???.???.???.???");
        }
        //set server name label
        ServerLabel.setText(config.getServerName());
        
        if(JLink.enableSysTray) {
            SysTrayMenuIcon sysTrayIcon = new SysTrayMenuIcon("kiss");
            sysTrayIcon.addSysTrayMenuListener(this);
            sysTray = new SysTrayMenu(sysTrayIcon);
            
            SysTrayMenuItem itemAbout = new SysTrayMenuItem("About...", "about");
            itemAbout.addSysTrayMenuListener(this);
            
            itemSkip = new SysTrayMenuItem("Skip", "skip");
            itemSkip.setEnabled(false);
            itemSkip.addSysTrayMenuListener(this);
            
            SysTrayMenuItem itemRestore = new SysTrayMenuItem("Restore", "restore");
            itemRestore.addSysTrayMenuListener(this);
            
            SysTrayMenuItem itemExit = new SysTrayMenuItem("Exit", "exit");
            itemExit.addSysTrayMenuListener(this);
            
            sysTray.addItem(itemExit);
            sysTray.addSeparator();
            sysTray.addItem(itemRestore);
            sysTray.addSeparator();
            sysTray.addItem(itemSkip);
            sysTray.addItem(itemAbout);
            updateToolTip();
        }
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        apply();
        addWindowListener(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroupSecurity = new javax.swing.ButtonGroup();
        ConfigPanel = new javax.swing.JPanel();
        AllTabs = new javax.swing.JTabbedPane();
        SharesTab = new javax.swing.JPanel();
        Up = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        Down = new javax.swing.JPanel();
        AddButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        EditButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        ServerTab = new javax.swing.JPanel();
        Server = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        ServerLabel = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        IpLabel = new javax.swing.JLabel();
        SecurityOption = new javax.swing.JPanel();
        allowAllButton = new javax.swing.JRadioButton();
        allowLocalButton = new javax.swing.JRadioButton();
        allowSpecButton = new javax.swing.JRadioButton();
        allowSpecTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        InfoTab = new javax.swing.JPanel();
        PlayerPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        playersComboBox = new javax.swing.JComboBox();
        playersComboBox.setRenderer(new JWindow.MyCellRenderer());
        jPanel2 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        nowPlayingLabel = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        playerIPLabel = new javax.swing.JLabel();
        Options = new javax.swing.JPanel();
        ExtensionPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        VideoExt = new javax.swing.JTextField();
        chkDispExtVid = new javax.swing.JCheckBox();
        jPanel5 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        AudioExt = new javax.swing.JTextField();
        chkDispExtAud = new javax.swing.JCheckBox();
        jPanel6 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        PictureExt = new javax.swing.JTextField();
        chkDispExtPict = new javax.swing.JCheckBox();
        oOptions = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        SendBuffer = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        userClean = new javax.swing.JTextField();
        chkClean = new javax.swing.JCheckBox();
        subControl = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        subExt = new javax.swing.JTextField();
        jPanel10 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        subProg = new javax.swing.JTextField();
        jPanel11 = new javax.swing.JPanel();
        subDelayApply = new javax.swing.JCheckBox();
        jLabel14 = new javax.swing.JLabel();
        subDelay = new javax.swing.JTextField();
        showTV = new javax.swing.JCheckBox();
        ButtonPanel = new javax.swing.JPanel();
        ApplyButton = new javax.swing.JButton();
        CloseButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("Hell Link v0.48");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        ConfigPanel.setLayout(new java.awt.BorderLayout());

        ConfigPanel.setPreferredSize(new java.awt.Dimension(480, 350));
        SharesTab.setLayout(new java.awt.GridBagLayout());

        SharesTab.setBackground(new java.awt.Color(255, 255, 255));
        Up.setLayout(new java.awt.GridBagLayout());

        Up.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        fs = config.getFileSystem();
        table.setModel(new MyTableModel(fs));
        table.setGridColor(new java.awt.Color(255, 255, 255));
        table.setPreferredSize(new java.awt.Dimension(400, 400));
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        table.setShowHorizontalLines(false);
        table.setShowVerticalLines(false);
        table.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tableMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(table);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        Up.add(jScrollPane1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 10.0;
        SharesTab.add(Up, gridBagConstraints);

        Down.setBackground(new java.awt.Color(255, 255, 255));
        AddButton.setText("Add");
        AddButton.setToolTipText("Share a new folder");
        AddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddButtonActionPerformed(evt);
            }
        });

        Down.add(AddButton);

        removeButton.setText("remove");
        removeButton.setToolTipText("Remove selected item from list");
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        Down.add(removeButton);

        EditButton.setText("Edit");
        EditButton.setToolTipText("Edit selected item");
        EditButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditButtonActionPerformed(evt);
            }
        });

        Down.add(EditButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        SharesTab.add(Down, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("All Kiss Path Must start with /VIDEO, /AUDIO or /PICTURE.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        SharesTab.add(jLabel1, gridBagConstraints);

        AllTabs.addTab("Shares", null, SharesTab, "Shared Folders");

        ServerTab.setLayout(new java.awt.GridBagLayout());

        ServerTab.setBackground(new java.awt.Color(255, 255, 255));
        Server.setLayout(new java.awt.GridBagLayout());

        Server.setBackground(new java.awt.Color(255, 255, 255));
        Server.setBorder(new javax.swing.border.TitledBorder("Server"));
        jLabel2.setText("Server Name :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 0);
        Server.add(jLabel2, gridBagConstraints);

        ServerLabel.setText("Hell Server");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.weightx = 5.0;
        Server.add(ServerLabel, gridBagConstraints);

        jLabel5.setText("Server IP Adress :");
        jLabel5.setToolTipText("");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 0);
        Server.add(jLabel5, gridBagConstraints);

        IpLabel.setText("x.x.x.x");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.weightx = 5.0;
        Server.add(IpLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ServerTab.add(Server, gridBagConstraints);

        SecurityOption.setLayout(new java.awt.GridBagLayout());

        SecurityOption.setBackground(new java.awt.Color(255, 255, 255));
        SecurityOption.setBorder(new javax.swing.border.TitledBorder("Security Options"));
        allowAllButton.setBackground(new java.awt.Color(255, 255, 255));
        allowAllButton.setText("Allow all connections");
        buttonGroupSecurity.add(allowAllButton);
        allowAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                allowAllButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 15);
        SecurityOption.add(allowAllButton, gridBagConstraints);

        allowLocalButton.setBackground(new java.awt.Color(255, 255, 255));
        allowLocalButton.setText("Allow only local connections (192.168.x.x 172.16.x.x-172.31.x.x 10.x.x.x)");
        buttonGroupSecurity.add(allowLocalButton);
        allowLocalButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                allowLocalButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 15);
        SecurityOption.add(allowLocalButton, gridBagConstraints);

        allowSpecButton.setBackground(new java.awt.Color(255, 255, 255));
        allowSpecButton.setText("Allow only specified addresses");
        buttonGroupSecurity.add(allowSpecButton);
        allowSpecButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                allowSpecButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 15, 0, 15);
        SecurityOption.add(allowSpecButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 35, 0, 15);
        SecurityOption.add(allowSpecTextField, gridBagConstraints);

        jLabel3.setText("Addresses seperated by ; (ex. 192.168.2.15; 192.168.0.10)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 35, 0, 15);
        SecurityOption.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 5.0;
        ServerTab.add(SecurityOption, gridBagConstraints);

        AllTabs.addTab("Server", null, ServerTab, "Server Options");

        InfoTab.setLayout(new java.awt.GridBagLayout());

        InfoTab.setBackground(new java.awt.Color(255, 255, 255));
        PlayerPanel.setLayout(new java.awt.GridBagLayout());

        PlayerPanel.setBackground(new java.awt.Color(255, 255, 255));
        PlayerPanel.setBorder(new javax.swing.border.TitledBorder("Players Info"));
        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel4.setText("Connected Players :");
        jPanel1.add(jLabel4);

        playersComboBox.setBackground(new java.awt.Color(255, 255, 255));
        playersComboBox.setMinimumSize(new java.awt.Dimension(180, 20));
        playersComboBox.setPreferredSize(new java.awt.Dimension(180, 20));
        playersComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playersComboBoxActionPerformed(evt);
            }
        });

        jPanel1.add(playersComboBox);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        PlayerPanel.add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel6.setText("Now Playing :");
        jPanel2.add(jLabel6);

        jPanel2.add(nowPlayingLabel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        PlayerPanel.add(jPanel2, gridBagConstraints);

        jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel8.setText("Player IP Adress :");
        jLabel8.setToolTipText("");
        jPanel3.add(jLabel8);

        jPanel3.add(playerIPLabel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        PlayerPanel.add(jPanel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        InfoTab.add(PlayerPanel, gridBagConstraints);

        AllTabs.addTab("Info", null, InfoTab, "Info About players");

        Options.setLayout(new java.awt.GridBagLayout());

        Options.setBackground(new java.awt.Color(255, 255, 255));
        ExtensionPanel.setLayout(new java.awt.GridBagLayout());

        ExtensionPanel.setBackground(new java.awt.Color(255, 255, 255));
        ExtensionPanel.setBorder(new javax.swing.border.TitledBorder("File Extension Display"));
        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel7.setText("Video Files :");
        jPanel4.add(jLabel7);

        VideoExt.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel4.add(VideoExt);

        chkDispExtVid.setBackground(new java.awt.Color(255, 255, 255));
        chkDispExtVid.setText("Display Extension");
        chkDispExtVid.setToolTipText("Display Extension on Tv Screen");
        jPanel4.add(chkDispExtVid);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ExtensionPanel.add(jPanel4, gridBagConstraints);

        jPanel5.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel5.setBackground(new java.awt.Color(255, 255, 255));
        jLabel9.setText("Audio Files :");
        jPanel5.add(jLabel9);

        AudioExt.setToolTipText("");
        AudioExt.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel5.add(AudioExt);

        chkDispExtAud.setBackground(new java.awt.Color(255, 255, 255));
        chkDispExtAud.setSelected(true);
        chkDispExtAud.setText("Display Extension");
        chkDispExtAud.setToolTipText("Display Extension on Tv Screen");
        jPanel5.add(chkDispExtAud);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ExtensionPanel.add(jPanel5, gridBagConstraints);

        jPanel6.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel6.setBackground(new java.awt.Color(255, 255, 255));
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel10.setText("Picture Files :");
        jPanel6.add(jLabel10);

        PictureExt.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel6.add(PictureExt);

        chkDispExtPict.setBackground(new java.awt.Color(255, 255, 255));
        chkDispExtPict.setSelected(true);
        chkDispExtPict.setText("Display Extension");
        chkDispExtPict.setToolTipText("Display Extension on Tv Screen");
        jPanel6.add(chkDispExtPict);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        ExtensionPanel.add(jPanel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        Options.add(ExtensionPanel, gridBagConstraints);

        oOptions.setLayout(new java.awt.GridBagLayout());

        oOptions.setBackground(new java.awt.Color(255, 255, 255));
        oOptions.setBorder(new javax.swing.border.TitledBorder("Others Options"));
        jPanel7.setBackground(new java.awt.Color(255, 255, 255));
        jLabel11.setText("Send buffer Size :");
        jPanel7.add(jLabel11);

        SendBuffer.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel7.add(SendBuffer);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        oOptions.add(jPanel7, gridBagConstraints);

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));
        userClean.setToolTipText("User List of Word to Clean");
        userClean.setPreferredSize(new java.awt.Dimension(250, 20));
        jPanel9.add(userClean);

        chkClean.setBackground(new java.awt.Color(255, 255, 255));
        chkClean.setSelected(true);
        chkClean.setText("CleanUp File Name");
        chkClean.setToolTipText("Clean File Name (Emule Style)");
        jPanel9.add(chkClean);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        oOptions.add(jPanel9, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        Options.add(oOptions, gridBagConstraints);

        subControl.setLayout(new java.awt.GridBagLayout());

        subControl.setBackground(new java.awt.Color(255, 255, 255));
        subControl.setBorder(new javax.swing.border.TitledBorder("Subtitle Control"));
        jPanel8.setBackground(new java.awt.Color(255, 255, 255));
        jLabel12.setText("Subtitle Files:");
        jPanel8.add(jLabel12);

        subExt.setToolTipText("Subtilte file extension");
        subExt.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel8.add(subExt);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        subControl.add(jPanel8, gridBagConstraints);

        jPanel10.setBackground(new java.awt.Color(255, 255, 255));
        jLabel13.setText("Subtitle Workshop Path :");
        jLabel13.setToolTipText("");
        jPanel10.add(jLabel13);

        subProg.setToolTipText("http://www.urusoft.net");
        subProg.setPreferredSize(new java.awt.Dimension(220, 20));
        jPanel10.add(subProg);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        subControl.add(jPanel10, gridBagConstraints);

        jPanel11.setBackground(new java.awt.Color(255, 255, 255));
        subDelayApply.setBackground(new java.awt.Color(255, 255, 255));
        subDelayApply.setToolTipText("Enable or Disable delay feature.");
        subDelayApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                subDelayApplyActionPerformed(evt);
            }
        });

        jPanel11.add(subDelayApply);

        jLabel14.setText("Delay (ms) :");
        jPanel11.add(jLabel14);

        subDelay.setToolTipText("Enter a positive or negative delay");
        subDelay.setPreferredSize(new java.awt.Dimension(220, 20));
        jPanel11.add(subDelay);

        showTV.setBackground(new java.awt.Color(255, 255, 255));
        showTV.setText("Show On TV");
        showTV.setToolTipText("Display Option Menu for delay on TV.");
        jPanel11.add(showTV);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        subControl.add(jPanel11, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        Options.add(subControl, gridBagConstraints);

        AllTabs.addTab("Options", null, Options, "More Options");

        ConfigPanel.add(AllTabs, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(ConfigPanel, gridBagConstraints);

        ButtonPanel.setLayout(new java.awt.GridBagLayout());

        ApplyButton.setText("Apply");
        ApplyButton.setToolTipText("Apply changes");
        ApplyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ApplyButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 3.0;
        gridBagConstraints.weighty = 1.0;
        ButtonPanel.add(ApplyButton, gridBagConstraints);

        CloseButton.setText("Close");
        CloseButton.setToolTipText("Close");
        CloseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CloseButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.weighty = 1.0;
        ButtonPanel.add(CloseButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(ButtonPanel, gridBagConstraints);

        pack();
    }//GEN-END:initComponents

    private void subDelayApplyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_subDelayApplyActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_subDelayApplyActionPerformed

    private void tableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tableMouseClicked
       if ((evt.getClickCount()>1) && (evt.getButton()== evt.BUTTON1) ) EditButtonActionPerformed(null);
    }//GEN-LAST:event_tableMouseClicked
    
    private void allowSpecButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_allowSpecButtonActionPerformed
        apply();
    }//GEN-LAST:event_allowSpecButtonActionPerformed
    
    private void allowLocalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_allowLocalButtonActionPerformed
        apply();
    }//GEN-LAST:event_allowLocalButtonActionPerformed
    
    private void allowAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_allowAllButtonActionPerformed
        apply();
    }//GEN-LAST:event_allowAllButtonActionPerformed
    
    private void playersComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playersComboBoxActionPerformed
        ClientHandler serv = (ClientHandler)playersComboBox.getSelectedItem();
        if(serv != null) {
            playerIPLabel.setText(serv.getPlayerIP().getHostAddress());
            nowPlayingLabel.setText(serv.getNowPlaying());
        } else {
            playerIPLabel.setText("");
            nowPlayingLabel.setText("");
        }
    }//GEN-LAST:event_playersComboBoxActionPerformed
    
    private void CloseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CloseButtonActionPerformed
        apply();
        setVisible(false);
        if(!JLink.enableSysTray)
            exit();
        dispose();
    }//GEN-LAST:event_CloseButtonActionPerformed
    
    private void ApplyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ApplyButtonActionPerformed
        apply();
        
    }//GEN-LAST:event_ApplyButtonActionPerformed
    
    private void EditButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditButtonActionPerformed
        int row = table.getSelectedRow();
        if (row > -1) {
            optionsDialog = new OptionsDialog(this, (Mount)fs.mounts.get(row));
            optionsDialog.setVisible(true);
        }
        table.repaint();
        
    }//GEN-LAST:event_EditButtonActionPerformed
    
    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        int row = table.getSelectedRow();
        if (row > -1) {
            fs.mounts.remove(row);
        }
        table.repaint();
    }//GEN-LAST:event_removeButtonActionPerformed
    
    private void AddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddButtonActionPerformed
        optionsDialog = new OptionsDialog(this, null);
        optionsDialog.setVisible(true);
        Mount m = optionsDialog.getMount();
        if(m != null)
            fs.mounts.add(m);
        table.repaint();
    }//GEN-LAST:event_AddButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    private void apply() {
        int securityModel = (allowAllButton.isSelected()?1:0) + (allowLocalButton.isSelected()?2:0) + (allowSpecButton.isSelected()?3:0);
        if(securityModel == 3) {
            allowSpecTextField.setEnabled(true);
            if(config.setAllowIP(allowSpecTextField.getText())) {
                JLink.error("Wrong format in allow IP textfield", this, false);
                config.setAllowIP("0.0.0.0");
            } else {
                allowSpecTextField.setText(config.getAllowIP());
            }
        } else {
            allowSpecTextField.setEnabled(false);
        }
        
        config.setServerName(ServerLabel.getText());
        config.setSecurityModel(securityModel);
        config.setExtFile(0,VideoExt.getText());
        config.setExtFile(1,AudioExt.getText());
        config.setExtFile(2,PictureExt.getText());
        config.setExtFile(3,subExt.getText());
        config.setBufferSize(SendBuffer.getText());
        String val="";
       
        config.setExtDisplay(0,chkDispExtVid.isSelected());
        config.setExtDisplay(1,chkDispExtAud.isSelected());
        config.setExtDisplay(2,chkDispExtPict.isSelected());
        config.setExtDisplay(3,subDelayApply.isSelected());
        config.setSubTV(showTV.isSelected());
        
        config.setCleanStrings(userClean.getText(),chkClean.isSelected());
        config.setSubProg(subProg.getText());
        config.setSubDelay(subDelay.getText());
       
        
        
        try {
            config.save();
        } catch(Exception err) {
            JLink.error("Unable to  configfile", this, false);
        }
    }
    
    private void exit(){
        if(playersComboBox.getItemCount() > 0) {
            Object[] options = { "   Yes   ", "   No   " };
            if(JOptionPane.showOptionDialog(this, "There are connected players to this PC.\nIf you exit those players will be disconnected!\nAre You sure you want to exit?", "Exit JLink while connected players?", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]) == 0) {
                dispose();
                System.exit(0);
            }
        } else {
            dispose();
            System.exit(0);
        }
    }
    
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JWindow(new JConfig("JLink.conf") ).show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton AddButton;
    private javax.swing.JTabbedPane AllTabs;
    private javax.swing.JButton ApplyButton;
    private javax.swing.JTextField AudioExt;
    private javax.swing.JPanel ButtonPanel;
    private javax.swing.JButton CloseButton;
    private javax.swing.JPanel ConfigPanel;
    private javax.swing.JPanel Down;
    private javax.swing.JButton EditButton;
    private javax.swing.JPanel ExtensionPanel;
    private javax.swing.JPanel InfoTab;
    private javax.swing.JLabel IpLabel;
    private javax.swing.JPanel Options;
    private javax.swing.JTextField PictureExt;
    private javax.swing.JPanel PlayerPanel;
    private javax.swing.JPanel SecurityOption;
    private javax.swing.JTextField SendBuffer;
    private javax.swing.JPanel Server;
    private javax.swing.JLabel ServerLabel;
    private javax.swing.JPanel ServerTab;
    private javax.swing.JPanel SharesTab;
    private javax.swing.JPanel Up;
    private javax.swing.JTextField VideoExt;
    private javax.swing.JRadioButton allowAllButton;
    private javax.swing.JRadioButton allowLocalButton;
    private javax.swing.JRadioButton allowSpecButton;
    private javax.swing.JTextField allowSpecTextField;
    private javax.swing.ButtonGroup buttonGroupSecurity;
    private javax.swing.JCheckBox chkClean;
    private javax.swing.JCheckBox chkDispExtAud;
    private javax.swing.JCheckBox chkDispExtPict;
    private javax.swing.JCheckBox chkDispExtVid;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nowPlayingLabel;
    private javax.swing.JPanel oOptions;
    private javax.swing.JLabel playerIPLabel;
    private javax.swing.JComboBox playersComboBox;
    private javax.swing.JButton removeButton;
    private javax.swing.JCheckBox showTV;
    private javax.swing.JPanel subControl;
    private javax.swing.JTextField subDelay;
    private javax.swing.JCheckBox subDelayApply;
    private javax.swing.JTextField subExt;
    private javax.swing.JTextField subProg;
    private javax.swing.JTable table;
    private javax.swing.JTextField userClean;
    // End of variables declaration//GEN-END:variables
    
    public void addPlayer(ClientHandler serv) {
        if(serv.getPlayerID() != null) {
            playersComboBox.addItem(serv);
            updateToolTip();
        }
    }
    
    public void removePlayer(ClientHandler serv) {
        playersComboBox.removeItem(serv);
        updateToolTip();
    }
    
    private void updateToolTip() {
        if(sysTray == null)
            return;
        String toolTip = JLink.TITLE;
        itemSkip.setEnabled(playersComboBox.getItemCount() > 0);
        for(int i = 0; i < playersComboBox.getItemCount(); i++) {
            ClientHandler serv = (ClientHandler)playersComboBox.getItemAt(i);
            String name = serv.getNowPlayingFileName();
            if(name != null) {
                toolTip += "\n" + ((name.length() > 40)?(name.substring(0,40 - 3) + "..."):name);
            }
        }
        sysTray.setToolTip(toolTip);
        
    }
    
    public void windowActivated(WindowEvent e) {
    }
    
    public void windowClosed(WindowEvent e) {
    }
    
    public void windowClosing(WindowEvent e) {
        if(JLink.enableSysTray)
            setVisible(false);
        else
            exit();
    }
    
    public void windowDeactivated(WindowEvent e) {
    }
    
    public void windowDeiconified(WindowEvent e) {
        
    }
    
    public void windowIconified(WindowEvent e) {
        if(JLink.enableSysTray) {
           
            setVisible(false);
        }
    }
    
    public void windowOpened(WindowEvent e) {
    }
    
    class MyCellRenderer extends JLabel implements ListCellRenderer {
        public MyCellRenderer() {
            setOpaque(true);
        }
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            ClientHandler serv = (ClientHandler)value;
            if(value != null)
                setText("KiSS DP-500 ID:" + serv.getPlayerID());
            else
                setText("");
            return this;
        }
    }
    
    public void iconLeftClicked(SysTrayMenuEvent e) {
      
        if(isVisible())
            setVisible(false);
        else {
            
            setVisible(true);
            toFront();
            setExtendedState(Frame.NORMAL);
            try{config.load();}
            catch(Exception ex){}
           subDelayApply.setSelected(config.getExtDisplay(3));
         subDelay.setText(config.getSubDelay());
        }
         
    }
    
    public void iconLeftDoubleClicked(SysTrayMenuEvent e) {
        try{config.load();}
            catch(Exception ex){}
        subDelayApply.setSelected(config.getExtDisplay(3));
         subDelay.setText(config.getSubDelay());
    }
    
    public void menuItemSelected(SysTrayMenuEvent e) {
      
        if(e.getActionCommand().equals("exit")) {
            exit();
        } else if(e.getActionCommand().equals("restore")) {
            setVisible(true);
            toFront();
            setExtendedState(Frame.NORMAL);
            try{config.load();}
            catch(Exception ex){}
            subDelayApply.setSelected(config.getExtDisplay(3));
            subDelay.setText(config.getSubDelay());
        
        } else if(e.getActionCommand().equals("skip")) {
            for(int i = 0; i < playersComboBox.getItemCount(); i++) {
                ClientHandler serv = (ClientHandler)playersComboBox.getItemAt(i);
                serv.skip();
            }
        } else if(e.getActionCommand().equals("about")) {
            JOptionPane.showMessageDialog(this, JLink.ABOUT);
        }
    }
    
    
    private class MyTableModel extends AbstractTableModel {
        FileSystem fs;
        String[] columnNames = {"Kiss Path", "Local Path"};
        
        public MyTableModel(FileSystem fs) {
            this.fs = fs;
        }
        
        public int getColumnCount() {
            return columnNames.length;
        }
        
        public int getRowCount() {
            return fs.mounts.size();
        }
        
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        public Object getValueAt(int row, int col) {
            if(col == 0)
                return ((Mount)fs.mounts.get(row)).getMountPoint();
            else
                return ((Mount)fs.mounts.get(row)).getMapPath();
        }
        
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
        
        public boolean isCellEditable(int row, int col) {
            return false;
        }
    }
}
