/***************************************************************************
                               systray4jd.cpp
                             ------------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstring.h> 
#include <qcstring.h>
 
#include <kapplication.h>
#include <kcmdlineargs.h>

#include <iostream>
using namespace std;

#include "systray4jd.h"
#include "transceiver.h"
#include "penguin.h"

SysTray4JavaDaemon* SysTray4JavaDaemon::s_pDaemon    = 0;
bool SysTray4JavaDaemon::s_initOk                    = false;

int main( int argc, char** argv )
{
    KCmdLineOptions options[] =
    {
        { "port <port>", "Sets the port to listen on.", ST4JDEFAULT_PORT },
        { 0, 0, 0 }
    };

    KCmdLineArgs::init( argc, argv, "systray4jd", "SysTray for Java Daemon.", "1.0" );
    KCmdLineArgs::addCmdLineOptions( options );

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    QCString arg = args->getOption( "port" );

    bool ok;
    unsigned short int port = arg.toUShort( &ok );

    if( ok )
    {
        if( !SysTray4JavaDaemon::init( port ) )
        {
            KApplication a;
        
            return a.exec();
        }
        else cout << "systray4jd: Socket creation failed. Try a different port." << endl;
    }
    else cout << "systray4jd: Invalid argument '" << arg << "'" << endl;

    return -1;
}

bool SysTray4JavaDaemon::init( unsigned short int port )
{
    s_pDaemon = new SysTray4JavaDaemon( port );

    return !s_initOk;
}

SysTray4JavaDaemon::SysTray4JavaDaemon( unsigned short int port )
{
    m_pMainSocket = new KServerSocket( port );
    if( m_pMainSocket->socket() > -1 )
    {
      #ifdef ST4JDEBUG_MODE
        cout << "listening on port " << port << endl;
      #endif

        connect( m_pMainSocket, SIGNAL( accepted( KSocket* ) ),
            SLOT( newConnection( KSocket* ) ) );

        s_initOk = true;
    }
}

void SysTray4JavaDaemon::newConnection( KSocket* connectedSocket )
{
    new Transceiver( connectedSocket );
}
