/***************************************************************************
                              systraymanager.h
                             ------------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SYSTRAYMANAGER_H
#define SYSTRAYMANAGER_H

#include <qobject.h>
#include <qptrlist.h>
#include <qpixmap.h>
#include <qdict.h>

class Transceiver;
class MenuBase;

class SysTrayManager : public QObject
{
    Q_OBJECT

    public :

        SysTrayManager( Transceiver* pTransceiver );
        ~SysTrayManager();

        MenuBase* findMenu( int menuId );

    protected :

        void customEvent( QCustomEvent* );

    private :

        QPixmap* getIcon( QString& iconFileName );

    private :

        QPtrList< MenuBase > m_menus;
        QDict< QPixmap > m_icons;
        Transceiver* m_pTransceiver;

        static QPixmap* s_pPenguin;
};

#endif
