/***************************************************************************
                               transceiver.h
                             -----------------
    begin                : 04.03.2003
    copyright            : (C) 2003 by Tamas Bara
    email                : tbara@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSCEIVER_H
#define TRANSCEIVER_H

//#define ST4JDEBUG_MODE

#include <qtextstream.h>
#include <qthread.h>
#include <qfile.h>
#include <qstringlist.h>

#include <ksock.h>

class SysTrayManager;

class Transceiver : public QThread
{
    public :

        enum
        {
            ICON_CLICKED       = 0,
            ICON_DBLCLICKED    = 1,
            ITEM_SELECTED      = 2,
            ADD_MAINMENU       = 3,
            ADD_SUBMENU        = 4,
            SET_ICON           = 5,
            SHOW_ICON          = 6,
            SET_TOOLTIP        = 7,
            ADD_ITEM           = 8,
            ENABLE_ITEM        = 9,
            CHECK_ITEM         = 10,
            SET_ITEMLABEL      = 11,
            REMOVE_ITEM        = 12,
            REMOVE_ALL         = 13,
            NUM_MESSAGES       = 14
        };

    public :

        Transceiver( KSocket* );
        ~Transceiver();

        void sendIconClicked( int menuId );
        void sendIconDblClicked( int menuId );
        void sendItemSelected( int menuId, int index );

    protected :

        void run();

    private :

        KSocket* m_pSocket;
        QFile* m_pFile;
        QTextStream m_stream;
        SysTrayManager* m_pManager;

    private :

        void addMainMenu();
        void addSubMenu();
        void setTooltip();
        void setIcon();
        void showIcon();
        void addItem();
        void enableItem();
        void checkItem();
        void setItemLabel();
        void removeItem();
        void removeAll();

    private :

        static char** MESSAGES;
        static void init();
};

#endif
